Name: vsftpd
Version: 1.1.2
%define pre_vers %nil
Release: alt1%pre_vers
%define srcname %name-%version%pre_vers

Summary: File Transfer Protocol (FTP) server
License: GPL
Group: System/Servers
Url: http://vsftpd.beasts.org/

# The primary site for releases is ftp://ferret.lmh.ox.ac.uk/pub/linux/
Source: ftp://ftp.beasts.org/users/cevans/%srcname.tar.bz2
Source1: %name.xinetd
Source2: %name.pamd
Source3: %name.logrotate
Source4: %name.banner_fail
Source5: %name.eps

Patch1: %name-1.1.0-alt-build.patch
Patch2: %name-1.1.1-alt-defaults.patch
Patch3: %name-1.1.0-owl-alt-pam_userpass.patch
Patch4: %name-1.1.0-alt-man.patch

Requires: /var/empty
Provides: ftpserver

# Automatically added by buildreq on Mon Dec 17 2001
BuildRequires: libcap-devel libpam-devel pam_userpass-devel

%description
%name is a File Transfer Protocol (FTP) server.  The "vs" stands for
Very Secure.  Obviously this is not a guarantee, but a reflection that
the entire codebase has been written with security in mind, and the
program has been carefully designed to be resilient to attack.

Recent evidence suggests that %name is also extremely fast (and this is
before any explicit performance tuning!) in tests against wu-ftpd, %name
was always faster, supporting over twice as many users in some tests.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%__install -p -m644 $RPM_SOURCE_DIR/%name.eps .

%build
%make_build

%install
%__install -pD -m755 %name $RPM_BUILD_ROOT%_sbindir/%name
%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/%name/user_conf
%__install -pD -m600 %name.conf $RPM_BUILD_ROOT%_sysconfdir/%name/conf
%__ln_s %name/conf $RPM_BUILD_ROOT%_sysconfdir/%name.conf
for f in $RPM_BUILD_ROOT{%_sysconfdir/%name/{banned_emails,chroot_list,user_list},%_logdir/%name.log}; do
	%__install -pD -m600 /dev/null "$f"
done

%__install -pD -m640 %SOURCE1 $RPM_BUILD_ROOT%_sysconfdir/xinetd.d/%name
%__install -pD -m640 %SOURCE2 $RPM_BUILD_ROOT%_sysconfdir/pam.d/%name
%__install -pD -m640 %SOURCE3 $RPM_BUILD_ROOT%_sysconfdir/logrotate.d/%name
%__install -pD -m600 %SOURCE4 $RPM_BUILD_ROOT%_sysconfdir/%name/banner_fail

%__install -pD -m644 %name.conf.5 $RPM_BUILD_ROOT%_man5dir/%name.conf.5
%__install -pD -m644 %name.8 $RPM_BUILD_ROOT%_man8dir/%name.8

%post
umask 077
/usr/sbin/groupadd -r -f %name &>/dev/null ||:
/usr/sbin/groupadd -r -f no%name &>/dev/null ||:
/usr/sbin/useradd -r -g %name -d /var/ftp -s /dev/null -n %name &>/dev/null ||:
/usr/sbin/useradd -r -g no%name -d /dev/null -s /dev/null -n no%name &>/dev/null ||:
touch %_logdir/%name.log

%files
%_sbindir/%name
%_sysconfdir/%name.conf
%attr(700,root,root) %dir %_sysconfdir/%name
%attr(700,root,root) %dir %_sysconfdir/%name/user_conf
%config(noreplace,missingok) %ghost %_sysconfdir/%name/banned_emails
%config(noreplace,missingok) %ghost %_sysconfdir/%name/chroot_list
%config(noreplace,missingok) %ghost %_sysconfdir/%name/user_list
%config(noreplace) %_sysconfdir/%name/banner_fail
%config(noreplace) %_sysconfdir/%name/conf
%config(noreplace) %_sysconfdir/xinetd.d/%name
%config(noreplace) %_sysconfdir/pam.d/%name
%config(noreplace) %_sysconfdir/logrotate.d/%name
%ghost %_logdir/%name.log
%_mandir/man?/*
%doc AUDIT BENCHMARKS BUGS Changelog EXAMPLE FAQ LICENSE
%doc README README.security REWARD SECURITY SIZE SPEED TODO TUNING
%doc %name.eps

%changelog
* Thu Oct 17 2002 Dmitry V. Levin <ldv@altlinux.org> 1.1.2-alt1
- 1.1.2:
  + Add per-IP connection limits in standalone mode.
  + Add logging of refused connect due to global or IP connection limits.
    (Many thanks for testing and suggestions from Rob van Nieuwkerk
    robn@verdi.et.tudelft.nl> and Adrian Reber <adrian@lisas.de>.
  + Make connection limit exceeded messages nonblocking.
  + Don't exit the listener if fork fails.
- Added flow control diagram
  (from Owl CanSecWest/core02 / NordU2002 presentation slides).

* Tue Oct 08 2002 Dmitry V. Levin <ldv@altlinux.org> 1.1.1-alt1
- 1.1.1:
  + Fix port_promiscuous, oops! Thanks to Bjrn-Ove Heimsund
    <bjornoh@mi.uib.no>.
  + Fix to support umasks which create executable files. Reported by
    "Martin, Andreas" <AMartin@hegau-klinikum.de>.
  + Make the messages more.. professional :( Thanks to Steven G. Taylor
    <staylor@redhat.com>.
  + Allow anon users to append to files if they can delete files! Suggestion
    from Michael Leuchtenburg <michael@slashhome.org>.
  + Hopefully fix Solaris build (-lresolv)
  + Replace atoll() with a homebrew - modern FreeBSD, OpenBSD lack it.
  + Different solution for a umask which creates executable files:
    file_open_mode.
  + First attempt at Tru64 build, working with <Sulla17@aol.com>.
  + A few minor FAQ additions.
  + Change date format in the log from Sep 09 -> Sep  9. Avoids breaking some
    broken log parsers.
  + Make "INSTALL" better and clearer.
  + Fix passwd_chroot_enable, reported by James Jones <james@richland.edu>.
  + Finish Tru64 building :-)
  + Add tunable_no_anon_password as asked for by Stephen Quinney
    <stephen.quinney@computing-services.oxford.ac.uk>.
- Updated URL.

* Wed Aug 07 2002 Dmitry V. Levin <ldv@altlinux.org> 1.1.0-alt1
- 1.1.0:
  + Use the seemingly more portable setreuid() and setregid(), poxy HP.
  + Use status 550 instead of 500 for known but disabled commands.
  + Rename "dirchange.[ch]" to "banner.[ch]".
  + Multiline connect banner support via "banner_file" config option.
  + Minor error message changes.
  + Add more FAQ entries.
  + Add patch to specify PASV address - thanks to Mike McLean <mikem@redhat.com>.
  + Drop the 2.4.0 kernel warning file
  + Rudimentary standalone listener support - to be expanded in a later release.
  + If sendfile() returns EINVAL just fall back to normal routines - handles
    non-pagecache backed files.
  + Add "port_promiscuous" setting - should help enabling FXP.
  + Modify anon_root and local_root to change directory _before_ applying the
    chroot().
  + Open all files O_NONBLOCK to avoid pipes blocking on open.
  + Support wu-ftpd style per-user chroot() via /./ in /etc/passwd HOMEDIR.
  + Add SIGHUP support to new built in listener.
  + Per-user config overrides, via "user_config_dir" - woohoo!
  + Warning fixes, i.e. change "index" to "indexx" thanks to Olaf Kirch <okir@suse.de>.
  + Make sure the standalone daemon doesn't leak zombies!
  + Supposedly fix kernel messages about MSG_PEEK race - thanks to advice from
    Alexey <kuznet@ms2.inr.ac.ru>.
  + Add global client limit for standalone mode.
  + Add username that failed when we die with str_getpwnam.
  + Add a bunch of documentation under EXAMPLES.
  + Add large file (>2Gb) support.
- Added %_sysconfdir/%name/banner_fail config file.
- Fixed vsftpd(8) (#0001113).

* Tue Apr 02 2002 Dmitry V. Levin <ldv@alt-linux.org> 1.0.2-alt0.1pre3
- 1.0.2pre3 (added options: use_localtime, hide_ids).
- Set hide_ids to YES.
- logrotate config: s/nocompress/delaycompress/.

* Mon Dec 17 2001 Dmitry V. Levin <ldv@alt-linux.org> 1.0.1-alt2
- Added pam_userpass support (derived from Owl's patch).

* Mon Dec 03 2001 Dmitry V. Levin <ldv@alt-linux.org> 1.0.1-alt1
- 1.0.1 (Nothing changed except version number).

* Thu Nov 29 2001 Dmitry V. Levin <ldv@alt-linux.org> 1.0.0-alt2
- Fixed typo in manpage.
- Create logfile in %%post script.

* Thu Nov 15 2001 Dmitry V. Levin <ldv@alt-linux.org> 1.0.0-alt1
- 1.0.0 (added options: anon_root, local_root; updated: BENCHMARKS, README).
- Added more examples to default config file.

* Wed Nov 07 2001 Dmitry V. Levin <ldv@alt-linux.org> 0.9.3-alt1
- Initial revision. ALT specific adaptions are:
  + all config files have been moved into %_sysconfdir/%name;
  + default guest, anonymous and nobody users are: %name, %name, no%name;
  + default config defines bsd-compatible passive min/max ports;
  + default secure_chroot_dir set to /var/empty;
  + xinetd config: disable = yes, rlimit_as = 16M;
  + pamd config: use pam_stack(system-auth), pam_nologin;
  + compile/link options cleanup.
